#ifndef AES_EXTRA
#define AES_EXTRA

#define G_CICON 33

typedef struct cicon_data
 {
  int                num_planes;  /* number of color bit planes    */
  int                *col_data;   /* -> color image for unselected */
  int                *col_mask;   /* -> bit mask for unselected    */
  int                *sel_data;   /* -> color image for selected   */
  int                *sel_mask;   /* -> bit mask for selected      */
  struct cicon_data  *next_res;   /* NULL for last resolution      */
 } CICON;

typedef struct cicon_blk
 {
  ICONBLK monoblk;           /* default monochrome icon block      */
  CICON   *mainlist;         /* -> linked list for resolutions     */
 } CICONBLK;

typedef union obspecptr
 {
  long            index;          /* type used for initialization  */
  union obspecptr *indirect;      /* ob_flag & INDIRECT            */
  bfobspec        obspec;         /* G_BOX, G_IBOX & G_BOXCHAR     */
  TEDINFO         *tedinfo;       /* G_TEXT, G_FTEXT, G_BOXTEXT &  */
                                  /* G_FBOXTEXT                    */
  ICONBLK         *iconblk;       /* G_ICON                        */
  CICONBLK        *ciconblk;      /* G_CICON - color icon          */
  BITBLK          *bitblk;        /* G_IMAGE                       */
  USERBLK         *userblk;       /* G_USERDEF                     */
  char            *free_string;   /* G_STRING, G_BUTTON & G_TITLE  */
 } OBSPEC;

#endif