/* MPEG2 Audio Layer2 Decoder */

#include <tos.h>
#include <vdi.h>
#include <aes.h>
#include <stdio.h>
#include <string.h>

#include "snddefs.h"
#include "mp2audio.h"

#include "mp2ctrl.rsh"	/* rsc file */
#include "mp2ctrl.rh"
#include "mp2wind.h"

/* global variables */
int fd, replay,file_open;
int ext, txt;
int app_id, acc_id, vdi_id;
int quit;
long block, buffer;
char buffer_mem[(long)BLOCK_SIZE];
WINDFORM windforms[5];

extern int _app;

/* global variables from mp2file.c */
extern char path[512], filename[512];
extern long filesize,filepos;

/* global variables from mp2event.c */
extern long total_time;

/* Function in this module */
void setup_rsrc(int nbpl);

/* Functions from mp2init.c */
extern int external_clock(void);
extern void init_replay(void);
extern int open_file(void);

/* Functions from mp2exit.c */
extern void exit_replay(void);

/* Functions from mp2file.c */
extern void close_file(int fd);
extern int reopen_file(void);

/* Function from mp2event.c */
extern void main_event_loop(void);
extern void fg_init(WINDFORM *wind);


int main(int argc, char *argv[])
{
	int wchar,hchar,wbar,hbar;
	int work_in[11]={ 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 2 };
	int work_out[57];

	/* dummies */
/*
	argc=argc;
	argv=argv;
*/
	
	replay = 0;
	ext=external_clock();
	txt = 1;
	block=(long)BLOCK_SIZE;

	if ((app_id = appl_init()) >= 0)
	{
		if(!_app)
			acc_id = menu_register(app_id, "  MPEG2 Audio ");
		
		work_in[0]=graf_handle(&wchar,&hchar,&wbar,&hbar);
		v_opnvwk(work_in,&vdi_id,work_out);
		if(vdi_id > 0)
		{
			vq_extnd(vdi_id,1,work_out);
			v_clsvwk(vdi_id);
			setup_rsrc(work_out[4]);
			if (_app) 
			{
				fg_init(&windforms[WIND_CTRL]);
				graf_mouse(ARROW,NULL);
				if(argc>1)
				{
					strcpy(path,argv[1]);
					strcpy(filename,&strrchr(argv[1], '\\')[1]);
					filepos=0;
					fd=reopen_file();
					filesize=Fseek(0L,fd,2);
					Fseek(0L,fd,0);
	
					init_replay();
				}
				main_event_loop();
				if (replay)
					exit_replay();
			} 
			else
			{
				if (acc_id >= 0)
					main_event_loop();
			}
		}
		appl_exit();
	}
	else
		fprintf(stderr, "Que pasa?\n");
	return 0;
}

void setup_rsrc(int nbpl)
{
	int ob;
	
	for(ob=0 ; ob<NUM_OBS ; ob++)
		rsrc_obfix(rs_object,ob);

	switch(nbpl)
	{
		case 1:
		case 2:
			windforms[WIND_CTRL].formtree=rs_trindex[FORM_CTRL1];
			windforms[WIND_INFO].formtree=rs_trindex[FORM_INFO1];
			break;
		case 4:
		default:
			windforms[WIND_CTRL].formtree=rs_trindex[FORM_CTRL4];
			windforms[WIND_INFO].formtree=rs_trindex[FORM_INFO4];
	}

	strcpy(windforms[WIND_CTRL].wind_title,"MPEG");
	strcpy(windforms[WIND_INFO].wind_title,"Info");
	windforms[WIND_CTRL].windkind=(MOVER | CLOSER | NAME);
	windforms[WIND_INFO].windkind=(MOVER | CLOSER | NAME);
	windforms[WIND_CTRL].firstobj=CTRL_FIRST;
	windforms[WIND_INFO].firstobj=INFO_FIRST;
	windforms[WIND_CTRL].objdepth=2;
	windforms[WIND_INFO].objdepth=1;
}
