#include <tos.h>
#include <aes.h>
#include <stdio.h>

#include "mp2info.h"

/* Function in this module */
int getmp2info(void);

/* global variable from mp2audio.c */
extern int fd;

/* global variable from mp2file.c */
extern long filesize;

/* global variable from mp2event.c */
extern long total_time;

/* global variable */
MP2INFO mp2info;

int getmp2info()
{
	FRAME_HEADER header;
/*	char tmp[128]; */
	
	Fread(fd,sizeof(FRAME_HEADER),(void *)&header);
	
	if(header.sync!=0xfff)
	{
		form_alert(1,"[3][Not a valid MPEG file!|No sync!][Ok]");
		return 0;
	}
	if(header.mode==MODE_MONO)
	{
		form_alert(1,"[3][No support for mono, yet!][Ok]");
		return 0;
	}
	if(header.protection==PROT_CRC)
	{
		form_alert(1,"[3][No support for CRC, yet!][Ok]");
		return 0;
	}
	
	mp2info.bitrate=bitrates[header.id][header.layer][header.bitrate];
	mp2info.sample_frequency=frequencies[header.id][header.frequency];
	mp2info.filelength=filesize;
	
	if(mp2info.bitrate<=0)
		return 0;
	total_time=mp2info.timelength=(mp2info.filelength*8)/mp2info.bitrate;

/*
	sprintf(tmp,"[1][Bitrate: %ld|Frequency: %ld|Total time: %02ld:%02ld][Ok]",
		mp2info.bitrate,mp2info.sample_frequency,mp2info.timelength/60,mp2info.timelength%60);
	form_alert(1,tmp);
*/	
	return 1;
}
